<template>
  <two-section
    left-caption="Монитор задач"
    right-caption="Задача"
    class="task-monitor"
    height-full
    min-left-width="350"
  >
    <template slot="left">
      <left-section
        ref="left-section"
        @onSelect="onSelect"
        @loadReady="loadReady = true"
      />
    </template>
    <template slot="right">
      <right-section
        v-if="isTaskSelected"
        :active-task="activeTaskItem"
        :task-info="taskInfo"
        :key="activeTaskItem.uuid"
        @getTasks="onGetTasks"
      />

      <div
        v-else
        class="task-not-selected"
      >
        Здесь будет содержание задачи
      </div>
    </template>
  </two-section>
</template>

<script>
import TwoSection from "common-components/src/obComponents/obTwoPanels";
import LeftSection from "./sections/LeftSection";
import RightSection from "./sections/RightSection";

export default {
  name: "TaskMonitor",
  components: {
    TwoSection,
    LeftSection,
    RightSection
  },
  data() {
    return {
      taskInfo: {
        role: "",
        type: ""
      },
      rightSectionData: {},
      activeTaskItem: {},
      loadReady: false
    };
  },
  computed: {
    isTaskSelected: ({ activeTaskItem, loadReady }) =>
      loadReady && Object.keys(activeTaskItem).length !== 0
  },
  methods: {
    onGetTasks() {
      this.loadReady = false;
      this.$refs['left-section'].loadTasks();
    },

    onSelect(el) {
      this.activeTaskItem = {};
      if (window.isShowOptions) console.log("Select element", el);
      if (el === undefined) return;
      this.activeTaskItem = el;
      this.taskInfo.role = this.activeTaskItem.card_type.split("_")[0];

      window.scrollTo({top: 0, behavior: 'smooth'});

      switch (this.activeTaskItem.type_code) {
        case "participant-by-security":
        case "participant-by-admin":
        case "resource-by-admin":
        case "resource-by-security":
          this.taskInfo.type = "constructor";
          break;
        case "participant-select-priority-field-values":
        case "resource-select-priority-field-values":
          this.taskInfo.type = "conflict";
          break;
        case "participant-key_fields_conflict":
        case "resource-key_fields_conflict":
          this.taskInfo.type = "keyConflict";
          break;
        default:
          this.taskInfo.type = "assessment";
          break;
      }
    }
  }
};
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";

.task-not-selected {
  @include font-mixin(24px, normal, 700, $taskMonitorPage-obTwoPanels-color_font_not_selected, 0.2px);
  padding: 40px 20px;
  top: 210px;
  position: absolute;
  left: 0;
  width: 100%;
  text-align: center;
}
</style>
